#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color2  Lime
#property  indicator_color3  Red
#property  indicator_color4  Red
#property  indicator_color5  Lime

#property  indicator_width2 2
#property  indicator_width3 2
#property  indicator_level1 0
 
extern int period=10;

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
double         ExtBuffer3[];

double         TmpBuffer0[];
double         TmpBuffer1[];



int init() {
   IndicatorBuffers(6);

   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);


   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,TmpBuffer0);
   SetIndexBuffer(1,ExtBuffer0);
   SetIndexBuffer(2,ExtBuffer1);
   SetIndexBuffer(3,ExtBuffer2);
   SetIndexBuffer(4,ExtBuffer3);

   SetIndexBuffer(5,TmpBuffer1);

   IndicatorShortName("Fisher");

   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);   
   SetIndexLabel(4,NULL);   

   return(0);
  }


int start() {
   //int     period=10;
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,old;
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price;
   double MinL=0;
   double MaxH=0;  
   

   limit=Bars-counted_bars-1;
   if (limit>1) limit=Bars-period-1;



   for(int i=limit; i>=0; i--) {  
      MaxH = High[iHighest(NULL,0,MODE_HIGH,period,i)];
      MinL = Low [iLowest (NULL,0,MODE_LOW, period,i)];
      price = (High[i]+Low[i])/2;
      TmpBuffer1[i]=0;
      if (MaxH-MinL>0) {
         TmpBuffer1[i]=0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*TmpBuffer1[i+1];
      
         TmpBuffer1[i]=MathMin(MathMax(TmpBuffer1[i],-0.999),0.999); 
      }
      TmpBuffer0[i]=0.5*(MathLog((1+TmpBuffer1[i])/(1-TmpBuffer1[i]))+TmpBuffer0[i+1]);
   }


   for(i=limit; i>=0; i--) {
      current=TmpBuffer0[i];
      prev=TmpBuffer0[i+1];
      ExtBuffer0[i]=0.0;           
      ExtBuffer1[i]=0.0;
      ExtBuffer2[i]=0.0;           
      ExtBuffer3[i]=0.0;

      if (current>0) {
         if (current>prev)
            ExtBuffer0[i]=current;
         else 
            ExtBuffer2[i]=current;
      } else {
         if (current<prev)
            ExtBuffer1[i]=current;
         else 
            ExtBuffer3[i]=current;
      }
   }

   return(0);
  }